package CDMA;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.lang.Math;
import Library.*;
import Library.Control.*;
import Library.Guide.*;
import Library.Code.*;

public class CDMA extends Tour {
	Screen         screen;
	CDMAControlBar control;
	CDMALayer      layer;
	CDMAGuide      guide;
	CDMACode       code;
	CDMAParameters P;
	CDMAStrings    S;

public CDMA(Applet parent, UniString title, Localization localization) {
	super(parent,title,localization);
	}

public  void initialize() {

	screen     = new Screen();
	control    = new CDMAControlBar();
	layer      = new CDMALayer();
	guide      = new CDMAGuide();
	code       = new CDMACode();
	P          = new CDMAParameters();
	S          = new CDMAStrings();
	};

public  void introduce() {
	screen.parent      = this;
	screen.setHistory();
	screen.history.code = code;

	control.parent     = this;
	control.screen     = screen;
	control.layer      = layer;
	control.guide      = guide;
	control.code       = code;
	control.P          = P;
	control.S          = S;

	layer.parent       = this;
	layer.screen       = screen;
	layer.control      = control;
	layer.guide        = guide;
	layer.code         = code;
	layer.P            = P;
	layer.S            = S;

	guide.parent       = this;
	guide.screen       = screen;
	guide.control      = control;
	guide.P            = P;
	guide.S            = S;

	code.parent       = this;
	code.screen       = screen;

	}

public  void setup() {
	setFrame(screen);

	guide.setup(LS.guideArranger,screen.screenRectangle);
	screen.addLayer(guide);

	code.setup(LS.codeArranger,screen.screenRectangle);
	screen.addLayer(code);

	control.setup(LS.controlArranger,screen.screenRectangle);
	screen.addLayer(control);

	layer.setup(S.layer,screen.screenRectangle);
	screen.addLayer(layer);

	control.setDisabled();
	screen.frame.setVisible(true);
	guide.nextScene(guide.scene);
	};

}

