package CDMA;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.lang.Math;
import Library.*;
import Library.Geometry.*;

public class CDMABar {
	CDMA3D  parent;
	int     type, user, item, index;
	R2D     rectangle;
	double  baseline;
	Color   color;
	double  value;
	CDMABar pred, next;
	double  epsilon = 0.005;


	static int signature   = 0;
	static int amplitude   = 1;
	static int transmitted = 2;
	static int received    = 3;

public CDMABar(CDMA3D  parent) {
	this.parent = parent;
	color       = null;
	value       = 0;
	pred        = null;
	next        = null;
	}

boolean mouseAction(C2D mousePosition, boolean setValue) {
	boolean result = false;
	double v = valueline();
	if(mousePosition.x >= rectangle.x)
	if(mousePosition.x <= rectangle.x+rectangle.w)
	if(mousePosition.y >= v - epsilon)
	if(mousePosition.y <= v + epsilon) {
		if(setValue) {
			value = (baseline - mousePosition.y) / (rectangle.h / 2);
			if(value < -1) value = -1;
			if(value >  1) value =  1;
			};
		result = true;
		};
	return result;
	}

double valueline() {
	if(rectangle == null) setRectangle();
	double v = value;
	if((type == transmitted)||(type == received)) v /= parent.parent.N;
	return baseline - v*rectangle.h/2;
	}

void setRectangle() {
	double x = 0, w = 0, h = 0;
	CDMASgnData sgnData = parent.parent.sgnData();
	int L = parent.parent.L;
	if(type == signature) {
		w = sgnData.w;
		x = sgnData.x + w * (L * index + item);
		baseline = sgnData.sgny + 2*user*sgnData.spacey;
		h = sgnData.sgnh;
		}
	else if(type == amplitude) {
		w = L * sgnData.w;
		x = sgnData.x + w * index;
		baseline = sgnData.sgny + (2*user+1)*sgnData.spacey;
		h = sgnData.sgnh;
		}
	else	{
		w = sgnData.w;
		x = sgnData.x + w * (L * index + item);
		baseline = sgnData.sigy;
		h = sgnData.sigh;
		};
	rectangle = new R2D(x,baseline-h,w,2*h);
	}

void setColor() {
	if(type == signature) {
		int L = parent.parent.L;
		double l = item; l /= L; l *= 128;
		int r = 127 + (int) l;
		int u = user % 3;
		if(u == 0) color = new Color(r,0,0);
		else if(u == 1) color = new Color(0,r,0);
		else color = new Color(0,0,r);
		}
	else if(type == amplitude) {
		int g = 127;
		color = new Color(g,g,g);
		}
	else	{
		int g = 127;
		color = new Color(g,0,g);
		}
	}

void paintRect(Paintbrush pb) {
	setRectangle();
	if(index%2 == 0) pb.setColor(new Color(255,255,255)); else pb.setColor(new Color(255,232,255));
	pb.fillRect(rectangle);
	}

void paint(Paintbrush pb) {
	setColor();
	if(parent.parent.control.sgnOutline.getState()) {
		pb.setColor(Color.blue);
		double y0 = baseline, y1 = y0;
		if(pred != null) y0 = pred.valueline();
		if(next != null) y1 = next.valueline();
		pb.drawLine(rectangle.x,y0,rectangle.x,valueline());
		pb.drawLine(rectangle.x,valueline(),rectangle.x+rectangle.w,valueline());
		pb.drawLine(rectangle.x+rectangle.w,valueline(),rectangle.x+rectangle.w,y1);
		}
	else	{
		pb.setColor(color);
		double v = valueline();
		pb.fillRect(rectangle.x,v,rectangle.w,baseline-v);
		};
	pb.setColor(Color.black);
	pb.drawLine(rectangle.x,baseline,rectangle.x+rectangle.w,baseline);
	}

}

