package CDMA;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.lang.Math;
import Library.*;
import Library.Control.*;

public class CDMAGuide extends Guide {
	CDMA             parent;
	CDMAControlBar   control;
	CDMAGuideStrings GS;
	CDMAParameters   P;
	LibraryStrings   LS;
	CDMAStrings      S;

        int i = 1;

	int signatures          = i++;
	int signal              = i++;
	int signatures2D        = i++;
	int signal2D            = i++;
	int samples2D           = i++;
	int decoding2D          = i++;
	int signatures3D        = i++;
	int signal3D            = i++;
	int samples3D           = i++;
	int decoding3D          = i++;

public void setup(UniString name, Rectangle rectangle) {
	super.setup(name,rectangle);
        scene = 1;
 	GS    = new CDMAGuideStrings();
	control.GS = GS;
	LS = screen.LS;
        lastScene      = --i;
	}

void sceneTitle (UniString s) {sceneNr = scene; sceneTitle = s;}

void action(ControlElement e) {control.actionPerformed(e);}
void select(StandardChoice ch, UniString s) {ch.select(s); action(ch);}
void check(StandardCheckbox cb, boolean value) {cb.setState(value); action(cb);}
void setValue(StandardIntField intf, int value) {intf.setIntValue(value); action(intf);}

void SectionChoice(UniString choice) {
	control.guideSectionChoice.select(choice);
//	action(control.guideSectionChoice);
	}

//public void nextScene(boolean forward) {
//	if(forward) {if(scene < lastScene) scene++;}
//	else        {if(scene > 1)         scene--;};
//	nextScene(scene);
//	}

boolean plot() {
	if(scene == signatures) return true;
	if(scene == signal)     return true;
	return false;
	}

boolean geo2D() {
	if(scene == signatures2D) return true;
	if(scene == signal2D)     return true;
	if(scene == samples2D)    return true;
	if(scene == decoding2D)   return true;
	return false;
	}

boolean geo3D() {
	if(scene == signatures3D) return true;
	if(scene == signal3D)     return true;
	if(scene == samples3D)    return true;
	if(scene == decoding3D)   return true;
	return false;
	}

public void nextScene(int scene) {

	if(this.scene != scene) {
		this.scene = scene;
		if(geo2D()) {
			setValue(control.NField,2);
			setValue(control.LField,2);
			setValue(control.PField,1);
			};
		if(geo3D()) {
			setValue(control.NField,3);
			setValue(control.LField,3);
			setValue(control.PField,1);
			};
		};
	check(control.showPlane,false);
	check(control.showPoints,false);
	check(control.showAxes,true);
	check(control.showVectors,true);
	check(control.showVector,false);
	check(control.showNormal,false);
        check(control.showSignatures,true);
        check(control.showAmplitudes,true);
        check(control.periodic,false);
        check(control.user0,true);
	action(control.zeroNoise);

	if(scene == signatures) {
		sceneTitle(GS.signatures);
		SectionChoice(GS.signatures);
       		check(control.periodic,true);
        	check(control.showAmplitudes,false);
		}
	if(scene == signal) {
		sceneTitle(GS.signal);
		SectionChoice(GS.signal);
       		check(control.periodic,true);
		}
	else if(scene == signatures2D) {
		sceneTitle(GS.signatures2D);
		SectionChoice(GS.signatures2D);
        	check(control.showAmplitudes,false);
		}
	else if(scene == signal2D) {
		sceneTitle(GS.signal2D);
		SectionChoice(GS.signal2D);
		check(control.showVector,true);
		}
	else if(scene == samples2D) {
		sceneTitle(GS.samples2D);
		SectionChoice(GS.samples2D);
		check(control.showPoints,true);
        	check(control.showAmplitudes,false);
       		check(control.showVectors,false);
		}
	else if(scene == decoding2D) {
		sceneTitle(GS.decoding2D);
		SectionChoice(GS.decoding2D);
		check(control.showPoints,true);
        	check(control.showAmplitudes,false);
       		check(control.showVectors,false);
		}
	else if(scene == signatures3D) {
		sceneTitle(GS.signatures3D);
		SectionChoice(GS.signatures3D);
       		check(control.showAmplitudes,false);
		}
	else if(scene == signal3D) {
		sceneTitle(GS.signal3D);
		SectionChoice(GS.signal3D);
       		check(control.showVector,true);
		}
	else if(scene == samples3D) {
		sceneTitle(GS.samples3D);
		SectionChoice(GS.samples3D);
		check(control.showAmplitudes,false);
		check(control.showPoints,true);
       		check(control.showVectors,false);
		}
	else if(scene == decoding3D) {
		sceneTitle(GS.decoding3D);
		SectionChoice(GS.decoding3D);
       		check(control.showAmplitudes,false);
		check(control.showPlane,true);
		check(control.showPoints,true);
		check(control.showVectors,false);
		};
	}

void place(boolean full) {
	control.placeElement(control.sgnOutline);
	if(plot()) {
		control.placeElement(control.NLabel,control.NField);
		control.placeElement(control.LLabel,control.LField);
		control.placeElement(control.PLabel,control.PField);
		}
	else if(scene == samples2D) {
		control.placeElement(control.user0);
		control.placeElement(control.user1);
		control.placeElement(control.showVectors);
		control.placeElement(control.noiseLabel,control.noiseField);
		control.placeElement(control.zeroNoise,control.lowNoise,control.highNoise);
		}
	else if(scene == decoding2D) {
		control.placeElement(control.user0);
		control.placeElement(control.user1);
		control.placeElement(control.showVectors);
		control.placeElement(control.showNormal);
		control.placeElement(control.noiseLabel,control.noiseField);
		control.placeElement(control.zeroNoise,control.lowNoise,control.highNoise);
		}
	else if(scene == samples3D) {
		control.placeElement(control.user0);
		control.placeElement(control.user1);
		control.placeElement(control.user2);
		control.placeElement(control.showVectors);
		control.placeElement(control.noiseLabel,control.noiseField);
		control.placeElement(control.zeroNoise,control.lowNoise,control.highNoise);
		}
	else if(scene == decoding3D) {
		control.placeElement(control.user0);
		control.placeElement(control.user1);
		control.placeElement(control.user2);
		control.placeElement(control.showVectors);
		control.placeElement(control.showNormal);
		control.placeElement(control.noiseLabel,control.noiseField);
        	control.placeElement(control.zeroNoise,control.lowNoise,control.highNoise);
		};
	}

}
