package Delis;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.lang.Math;
import Library.*;
import Library.Geometry.*;
import Library.Code.*;

public class Delis extends Tour {
	Screen              screen;
	DelisControlBar     control;
	DelisLayer          layer;
	DelisGuide          guide;
	DelisCode           code;
	DelisParameters     P;
	DelisStrings        S;
	DelisGuideStrings   GS;

public Delis(Applet parent, UniString title, Localization localization) {super(parent,title,localization);}

public  void initialize() {
	
	screen        = new Screen();
	control       = new DelisControlBar();
	layer         = new DelisLayer();

	guide         = new DelisGuide();
	code          = new DelisCode();
	P             = new DelisParameters();
	S             = new DelisStrings();
	GS            = new DelisGuideStrings(guide);
	};

public  void introduce() {
	screen.parent      = this;
	screen.setHistory();
	screen.history.code = code;

	control.parent      = this;
	control.P           = P;
	control.S           = S;
	control.GS          = GS;
	control.screen      = screen;
	control.layer       = layer;
	control.guide       = guide;

	layer.parent     = this;
	layer.P          = P;
	layer.S          = S;
	layer.GS         = GS;
	layer.screen     = screen;
	layer.guide      = guide;
	layer.control    = control;

	guide.parent      = this;
	guide.P           = P;
	guide.S           = S;
	guide.GS          = GS;
	guide.screen      = screen;
	guide.control     = control;
	guide.layer       = layer;

	code.parent      = this;
	code.screen      = screen;
	}

public  void setup() {
	setFrame(screen);

	guide.setup(LS.guideArranger,screen.screenRectangle);
	screen.addLayer(guide);

	code.setup(LS.codeArranger,screen.screenRectangle);
	screen.addLayer(code);

	control.setup(LS.controlArranger,screen.screenRectangle);
	screen.addLayer(control);

	layer.setup(S.Delis,screen.screenRectangle);
	screen.addLayer(layer);

	screen.frame.setVisible(true);
	screen.animationSteps = 12;
	control.speedField.setIntValue(screen.animationSteps);
	};

}
