package Delis;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.lang.Math;
import Library.*;
import Library.Geometry.*;
import Library.Code.*;


public class DelisExplanation {
	DelisLayer layer;
	Paintbrush pb;
	double x;
	double y;

public DelisExplanation(DelisLayer layer) {
	this.layer = layer;
	}

public void paint(Paintbrush pb) {
	this.pb = pb;
	DelisGuide guide = layer.guide;
	int scene = guide.scene;
	pb.setColor(Color.blue);
	pb.fillRect(layer.explanationRectangle);
	pb.setColor(Color.white);
	pb.setFont(0.025);
	x = layer.explanationRectangle.x + 0.025;
	y = layer.explanationRectangle.y + 0.04;
	if(scene==guide.randomRadius)               paintRandomRadius();
	else if(scene==guide.uniformRadius)         paintUniformRadius();
	else if(scene==guide.uniformRadiusBiased)   paintUniformRadiusBiased();
	else if(scene==guide.uniformRadiusLattice)  paintUniformRadiusLattice();
	else if(scene==guide.NNG)                   paintNNG();
	else if(scene==guide.NNGBiased)             paintNNGBiased();
	else if(scene==guide.NNGStrongBiased)       paintNNGStrongBiased();
	else if(scene==guide.lowDegree)             paintLowDegree();
	else if(scene==guide.lowDegreeStrongBiased) paintLowDegreeStrongBiased();
	else if(scene==guide.bridge)                paintBridge();
	else if(scene==guide.bridgePlot)            paintBridgePlot();
	else if(scene==guide.bridgeScream)          paintBridgeScream();
	}

void line(String s) {pb.drawString(s,x,y); y += 0.03;}

void paintRandomRadius() {
	line("Points in the rectangle on the left side represent agents that communicate using");
	line("a wireless network. We will call them nodes. A green circle around each node shows");
	line("how far the signal of a node could be heard");
	line("In our simplified model we assume that a signal is isotropic (its intensity decreases");
	line("in the same same rate in all directions) and we do not consider interference and");
	line("similar effects.");
	line("Push the button [More power] - the power of transmitters in the nodes increases and");
	line("hence the radii of circles increase. The button [Less power] acts in the opposite direction");
	line("If a node B is within the circle of a node B (i.e., B hears A) and, conversely,");
	line("A hears B, then there is a direct bi-directional connection between A and B, which");
	line("is marked by a line connecting A and B. The meaning of the color of the line will be");
	line("explained later");
	}

void paintUniformRadius() {
	
	}

void paintUniformRadiusBiased() {
	
	}

void paintUniformRadiusLattice() {
	
	}

void paintNNG() {
	
	}

void paintNNGBiased() {
	
	}

void paintNNGStrongBiased() {
	
	}

void paintLowDegree() {
	
	}

void paintLowDegreeStrongBiased() {
	
	}

void paintBridge() {
	
	}

void paintBridgePlot() {
	
	}

void paintBridgeScream() {
	
	}

}
