package Delis;


import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.lang.Math;
import java.lang.*;
import Library.*;
import Library.Geometry.*;
import Library.Control.*;
import Library.History.*;
import Library.Code.*;

public class DelisGuide extends Guide {
	Delis             parent;
	DelisControlBar   control;
	DelisLayer        layer;
	DelisCode         code;
	DelisParameters   P;
	DelisStrings      S;
	DelisGuideStrings GS;
	LibraryStrings    LS;

	int scene;
	int subscene;
	int oldScene = 0;

        int i = 0;
	int opening               = i++;
	int randomRadius          = i++;
	int uniformRadius         = i++;
	int uniformRadiusBiased   = i++;
	int uniformRadiusLattice  = i++;
	int NNG                   = i++;
	int NNGBiased             = i++;
	int NNGStrongBiased       = i++;
	int lowDegree             = i++;
	int lowDegreeStrongBiased = i++;
	int bridge                = i++;
	int bridgePlot            = i++;
	int bridgeScream          = i++;
	int lastScene = --i;

public void setup(UniString name, Rectangle rectangle) {
	super.setup(name,rectangle);
        scene = 0;
	LS = screen.LS;
	}

void sceneTitle (int title) {
	sceneNr = scene;
 	sceneTitle = GS.scene[title];
	}

void action(ControlElement e) {control.actionPerformed(e);}
void select(StandardChoice ch, UniString s) {ch.select(s); action(ch);}
void check(StandardCheckbox cb, boolean value) {cb.setState(value); action(cb);}

void SectionChoice(int choice) {
	boolean b = control.guideSectionChoice.select(GS.scene[choice]);
	}

public void nextScene(boolean forward) {
	int newScene = scene;
	if(forward) {if(scene < lastScene) newScene = scene + 1;}
	else        {if(scene > 0)         newScene = scene - 1;};
	nextScene(newScene);
	}



public void nextScene(int scene) {
	oldScene = this.scene;
	this.scene = scene;
	check(control.showTransmit,false);
	check(control.showEdges,true);
	check(control.showLattice,false);
	check(control.computeBridges,false);
	check(control.showPowerPlot,false);
	check(control.showCongestionPlot,false);

	if(scene==randomRadius) {
		sceneTitle(randomRadius);
		SectionChoice(randomRadius);
		select(control.modelChoice,S.randomRadius);
		select(control.inputChoice,S.uniformlyRandom);
		check(control.showTransmit,true);
		}
	else if(scene==uniformRadius) {
		sceneTitle(uniformRadius);
		SectionChoice(uniformRadius);
		select(control.modelChoice,S.uniformRadius);
		select(control.inputChoice,S.uniformlyRandom);
		check(control.showTransmit,true);
		}
	else if(scene==uniformRadiusBiased) {
		sceneTitle(uniformRadiusBiased);
		SectionChoice(uniformRadiusBiased);
		select(control.modelChoice,S.uniformRadius);
		select(control.inputChoice,S.isolatedPoint);
		check(control.showTransmit,false);
		}
	else if(scene==uniformRadiusLattice) {
		sceneTitle(uniformRadiusLattice);
		SectionChoice(uniformRadiusLattice);
		select(control.modelChoice,S.uniformRadius);
		select(control.inputChoice,S.uniformlyRandom);
		check(control.showLattice,true);
		select(control.latticeBoxSelectChoice,S.nonemptyCenter);
		select(control.latticeBoxDisplayChoice,S.displayAll);
		}
	else if(scene==NNG) {
		sceneTitle(NNG);
		SectionChoice(NNG);
		select(control.modelChoice,S.nng);
		select(control.inputChoice,S.uniformlyRandom);
		}
	else if(scene==NNGBiased) {
		sceneTitle(NNGBiased);
		SectionChoice(NNGBiased);
		select(control.modelChoice,S.nng);
		select(control.inputChoice,S.isolatedPoint);
		}
	else if(scene==NNGStrongBiased) {
		sceneTitle(NNGStrongBiased);
		SectionChoice(NNGStrongBiased);
		select(control.modelChoice,S.nng);
		select(control.inputChoice,S.isolatedCluster);
		}
	else if(scene==lowDegree) {
		sceneTitle(lowDegree);
		SectionChoice(lowDegree);
		select(control.modelChoice,S.lowDegree);
		select(control.inputChoice,S.uniformlyRandom);
		}
	else if(scene==lowDegreeStrongBiased) {
		sceneTitle(lowDegreeStrongBiased);
		SectionChoice(lowDegreeStrongBiased);
		select(control.modelChoice,S.lowDegree);
		select(control.inputChoice,S.isolatedCluster);
		}
	else if(scene==bridge) {
		sceneTitle(bridge);
		SectionChoice(bridge);
		select(control.modelChoice,S.lowDegree);
		select(control.inputChoice,S.uniformlyRandom);
		check(control.computeBridges,true);
		}
	else if(scene==bridgePlot) {
		sceneTitle(bridgePlot);
		SectionChoice(bridgePlot);
		select(control.modelChoice,S.lowDegree);
		select(control.inputChoice,S.uniformlyRandom);
		check(control.computeBridges,true);
		check(control.showPowerPlot,true);
		check(control.showCongestionPlot,true);
		}
	else if(scene==bridgeScream) {
		sceneTitle(bridgeScream);
		SectionChoice(bridgeScream);
		select(control.modelChoice,S.lowDegree);
		select(control.inputChoice,S.uniformlyRandom);
		check(control.computeBridges,true);
		};

	}

boolean bridgeScene() {
	if(scene == bridge) return true;
	if(scene == bridgePlot) return true;
	if(scene == bridgeScream) return true;
	 return false;
	}

void place(boolean full) {
	if(!bridgeScene())
		control.placeElement(control.lessPowerButton,control.morePowerButton);

	control.placeElement(control.newInput);
	control.placeElement(control.nLabel,control.nField);
	if(scene==randomRadius) {
		control.placeElement(control.showTransmit);
		control.placeElement(control.showEdges);
		}
	else if(scene==uniformRadius) {
		control.placeElement(control.showTransmit);
		control.placeElement(control.showEdges);
		}
	else if(scene==uniformRadiusBiased) {
		control.placeElement(control.showTransmit);
		control.placeElement(control.biasedLabel,control.biasedField);
		}
	else if(scene==uniformRadiusLattice) {
		control.placeElement(control.latticeBoxLabel,control.latticeBoxField);
		}
	else if(scene==NNG) {
		control.placeElement(control.showTransmit);
		}
	else if(scene==NNGBiased) {
		control.placeElement(control.showTransmit);
		control.placeElement(control.biasedLabel,control.biasedField);
		}
	else if(scene==NNGStrongBiased) {
		control.placeElement(control.showTransmit);
		control.placeElement(control.biasedLabel,control.biasedField);
		control.placeElement(control.clusterLabel,control.clusterField);
		}
	else if(scene==lowDegree) {
		control.placeElement(control.showTransmit);
		}
	else if(scene==lowDegreeStrongBiased) {
		control.placeElement(control.showTransmit);
		control.placeElement(control.biasedLabel,control.biasedField);
		control.placeElement(control.clusterLabel,control.clusterField);
		}
	else if(bridgeScene()) {
		if(layer.network.node[0].componentSize() < layer.network.size()) {
			control.placeElement(control.lessPowerButton,control.morePowerButton);

			}
		else	{
			control.placeElement(control.bridgeButton);
			if(scene == bridgeScream)
				control.placeElement(control.phaseButton);
			};
		};
	control.placeElement(control.showExplanation);
	}

}

