package Delis;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.lang.Math;
import Library.*;
import Library.History.*;
import Library.Geometry.*;

public class WirelessEdge {
	WirelessNetwork network;
	WirelessEdge next;
	WirelessNode n1,n2;
	Color color;
	boolean thick;

	boolean automaticColor;

public WirelessEdge(WirelessNetwork network, WirelessNode n1, WirelessNode n2) {
	this.network = network;
	this.n1 = n1;
	this.n2 = n2;
	color = Color.red;
	next = null;
	thick = false;

	automaticColor = true;
	}

double length() {

	return C2D.distance(n1.position,n2.position);

	}

public void setColor() {
	if(n1.componentSize() == network.size()) color = Color.black;
	else if(n1.componentSize() >= network.size()/2) color = new Color(255,0,0);
	else if(n1.componentSize() >= network.largestComponentSize()) color = new Color(255,0,255);
	else color = Color.blue;
	}

public void paint(Paintbrush pb) {
	if(!network.layer.control.showEdges.checked()) return;
	if(automaticColor) setColor();
	pb.setColor(color);
	C2D pos1 = network.position2paint(n1.position);
	C2D pos2 = network.position2paint(n2.position);
	double r = network.dimension2paint(n1.nodeLargeRadius)/2;
	if((network.drawWideEdges) || thick)
		pb.drawThickLine(pos1,pos2,r);
	else
		pb.drawLine(pos1,pos2);
	}

}
