package Delis;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.lang.Math;
import Library.*;
import Library.Graph.*;
import Library.Geometry.*;

public class WirelessLattice {
	WirelessNetwork network;
	int nBoxes;
	WirelessLatticeBox[][] box;
	double boxSize;
	double cellSize;
	
public WirelessLattice(WirelessNetwork network, int nBoxes) {
	this.network = network;
	this.nBoxes = nBoxes;
	boxSize  = 1; boxSize  /= nBoxes;
	cellSize = boxSize / 4;
	reset();
	}

public WirelessLatticeBox box(Point i) {return box[i.x][i.y];}

public void reset() {  
	box = new WirelessLatticeBox[nBoxes][];
	for(int i=0; i<nBoxes; i++) {
		box[i] = new WirelessLatticeBox[nBoxes];
		for(int j=0; j<nBoxes; j++)
			box[i][j] = new WirelessLatticeBox(this,new Point(i,j));
		};
	considerNodes();
	}

Point boxIndex(C2D position) {
	int ix = (int) (nBoxes * position.x);
	int iy = (int) (nBoxes * position.y);
	return new Point(ix,iy);
	}

public void considerNodes() {
	for(int i=0; i<nBoxes; i++) for(int j=0; j<nBoxes; j++)
		box[i][j].forgetPoints();
	 if(network.node != null) for(int k=0; k<network.size(); k++) {
		C2D pos = network.node[k].position;
		Point index = boxIndex(pos);
		box[index.x][index.y].considerPoint(pos);
		};
	}

public void paint(Paintbrush pb) {
	for(int i = 0; i < nBoxes; i++)
	for(int j = 0; j < nBoxes; j++)
		box[i][j].paint(pb);
	}

}
