package Delis;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.lang.Math;
import java.util.Random;
import Library.*;
import Library.History.*;
import Library.Geometry.*;

public class WirelessNodeRadiusChange extends Animator {
	WirelessNode node;
	double       fromRadius;
	double       uptoRadius;

public WirelessNodeRadiusChange(History history, Layer layer, WirelessNode node, double finalRadius) {
	super(history,layer);
	this.node = node;
	fromRadius = node.transmitRadius;
	uptoRadius = finalRadius;
	}

public void update(boolean forward, int animationSteps, int step) {
	node.network.edgesInvalid = true;
	node.transmitRadius = history.getScreen().interpolateDouble(animationSteps,step,uptoRadius,fromRadius);
	}

public String toString() {return "Radius Change "+fromRadius+" "+uptoRadius;}

}

